#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire900four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire900four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four9004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2four9004xi = {
                1:'103x-42y892z',
                2:'113x-186y873z',
                3:'114x-40y891z',
                4:'124x-36y890z',
                5:'128x-187y870z',
                6:'135x-32y889z',
                7:'137x-868y193z',
                8:'143x-186y868z',
                9:'145x-26y887z',
                10:'147x-358y812z',
                11:'155x-20y886z',
                12:'158x-185y866z',
                13:'164x-12y884z',
                14:'169x-357y808z',
                15:'174x-183y863z',
                16:'174x-4y882z',
                17:'183x-861y185z',
                18:'189x-180y861z',
                19:'191x-354y804z',
                20:'205x-175y858z',
                21:'214x-351y800z',
                22:'221x-169y855z',
                23:'228x-852y176z',
                24:'236x-162y852z',
                25:'236x-346y796z',
                26:'240x-508y702z',
                27:'252x-154y850z',
                28:'259x-339y792z',
                29:'267x-145y847z',
                30:'269x-501y697z',
                31:'273x-840y167z',
                32:'281x-331y787z',
                33:'282x-134y843z',
                34:'296x-123y840z',
                35:'299x-492y691z',
                36:'304x-322y783z',
                37:'310x-110y837z',
                38:'317x-827y158z',
                39:'323x-96y834z',
                40:'326x-311y778z',
                41:'328x-481y685z',
                42:'332x-618y563z',
                43:'336x-80y830z',
                44:'348x-298y774z',
                45:'348x-64y827z',
                46:'357x-469y679z',
                47:'359x-47y823z',
                48:'360x-810y149z',
                49:'367x-605y556z',
                50:'369x-284y769z',
                51:'369x-29y819z',
                52:'379x-10y816z',
                53:'385x-455y673z',
                54:'390x-269y764z',
                55:'401x-589y548z',
                56:'403x-792y140z',
                57:'410x-252y760z',
                58:'413x-439y667z',
                59:'429x-234y755z',
                60:'434x-572y541z',
                61:'441x-421y661z',
                62:'445x-770y131z',
                63:'447x-214y750z',
                64:'45x-873y211z',
                65:'465x-194y745z',
                66:'467x-402y655z',
                67:'467x-552y534z',
                68:'482x-171y740z',
                69:'485x-747y123z',
                70:'493x-381y649z',
                71:'497x-148y735z',
                72:'499x-531y527z',
                73:'511x-124y729z',
                74:'517x-358y643z',
                75:'524x-722y114z',
                76:'524x-98y724z',
                77:'530x-508y519z',
                78:'536x-71y719z',
                79:'53x-40y897z',
                80:'541x-334y636z',
                81:'546x-44y713z',
                82:'555x-15y708z',
                83:'560x-482y512z',
                84:'562x-694y105z',
                85:'563x-308y630z',
                86:'584x-281y623z',
                87:'588x-456y505z',
                88:'598x-664y96z',
                89:'604x-252y617z',
                90:'616x-427y497z',
                91:'61x-172y881z',
                92:'622x-222y610z',
                93:'62x-43y896z',
                94:'633x-633y87z',
                95:'638x-191y604z',
                96:'641x-397y490z',
                97:'653x-159y597z',
                98:'666x-365y482z',
                99:'666x-599y78z',
                100:'667x-126y590z',
                101:'678x-91y583z',
                102:'688x-332y474z',
                103:'688x-56y577z',
                104:'696x-20y570z',
                105:'697x-564y69z',
                106:'709x-297y467z',
                107:'726x-527y60z',
                108:'72x-44y895z',
                109:'73x-177y879z',
                110:'753x-489y51z',
                111:'778x-449y42z',
                112:'801x-408y33z',
                113:'809x-290y510z',
                114:'821x-365y24z',
                115:'82x-44y895z',
                116:'840x-322y15z',
                117:'855x-278y6z',
                118:'86x-181y877z',
                119:'91x-872y202z',
                120:'93x-44y894z',
                121:'99x-184y875z'}      #"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire900four4xi" usage = "target function for charge9004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire900four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE900FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE900FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE900FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE900FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE900FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four9004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE900FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE900FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE900FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four9004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four9004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE900FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE900FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE900FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire900four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                    